### =========================================================================
### excluderanges metadata
### -------------------------------------------------------------------------
###

meta <- data.frame(
    Title = c("ce10.Kundaje.ce10-Excludable.rds", 
              "dm3.Kundaje.dm3-Excludable.rds", 
              "hg19.Bernstein.Mint_Excludable_hg19.rds", 
              "hg19.Birney.wgEncodeDacMapabilityConsensusExcludable.rds", 
              "hg19.Crawford.wgEncodeDukeMapabilityRegionsExcludable.rds", 
              "hg19.Wold.hg19mitoExcludable.rds", 
              "hg19.Yeo.eCLIP_Excludableregions.hg19.rds", 
              "hg38.Bernstein.Mint_Excludable_GRCh38.rds", 
              "hg38.Kundaje.GRCh38.Excludable.rds", 
              "hg38.Kundaje.GRCh38_unified_Excludable.rds", 
              "hg38.Reddy.wgEncodeDacMapabilityConsensusExcludable.hg38.rds", 
              "hg38.Wold.hg38mitoExcludable.rds", 
              "hg38.Yeo.eCLIP_Excludableregions.hg38liftover.bed.fixed.rds", 
              "mm10.Hardison.Excludable.full.rds", 
              "mm10.Hardison.psuExcludable.mm10.rds", 
              "mm10.Kundaje.anshul.Excludable.mm10.rds", 
              "mm10.Kundaje.mm10.Excludable.rds", 
              "mm10.Wold.mm10mitoExcludable.rds", 
              "mm9.Wold.mm9mitoExcludable.rds",
              "hg19.UCSC.centromere.rds", 
              "hg19.UCSC.clone.rds", 
              "hg19.UCSC.contig.rds", 
              "hg19.UCSC.heterochromatin.rds", 
              "hg19.UCSC.scaffold.rds", 
              "hg19.UCSC.short_arm.rds", 
              "hg19.UCSC.telomere.rds", 
              "hg38.UCSC.contig.rds", 
              "hg38.UCSC.heterochromatin.rds", 
              "hg38.UCSC.scaffold.rds", 
              "hg38.UCSC.short_arm.rds", 
              "hg38.UCSC.telomere.rds", 
              "mm10.UCSC.centromere.rds", 
              "mm10.UCSC.clone.rds", 
              "mm10.UCSC.contig.rds", 
              "mm10.UCSC.fragment.rds", 
              "mm10.UCSC.other.rds", 
              "mm10.UCSC.short_arm.rds", 
              "mm10.UCSC.telomere.rds", 
              "mm9.UCSC.centromere.rds", 
              "mm9.UCSC.contig.rds", 
              "mm9.UCSC.fragment.rds",
              "mm10.UCSC.scaffold.rds"),
    Description = c("Exclusion regions for ce10 by Anshul Kundaje, Stanford", 
                    "Exclusion regions for dm3 by Anshul Kundaje, Stanford", 
                    "Exclusion regions for hg19 by Bradley Bernstein, Broad", 
                    "Exclusion regions for hg19 by Ewan Birney, EBI", 
                    "Exclusion regions for hg19 by Gregory Crawford, Duke", 
                    "Exclusion regions for hg19 by Barbara Wold, Caltech", 
                    "Exclusion regions for hg19 by Gene Yeo, UCSD", 
                    "Exclusion regions for hg38 by Bradley Bernstein, Broad", 
                    "Exclusion regions for hg38 by Anshul Kundaje, Stanford", 
                    "Exclusion regions for hg38 by Anshul Kundaje, Stanford", 
                    "Exclusion regions for hg38 by Tim Reddy, Duke", 
                    "Exclusion regions for hg38 by Barbara Wold, Caltech", 
                    "Exclusion regions for hg38 by Gene Yeo, UCSD", 
                    "Exclusion regions for mm10 by Ross Hardison, PennState", 
                    "Exclusion regions for mm10 by Ross Hardison, PennState", 
                    "Exclusion regions for mm10 by Anshul Kundaje, Stanford", 
                    "Exclusion regions for mm10 by Anshul Kundaje, Stanford", 
                    "Exclusion regions for mm10 by Barbara Wold, Caltech", 
                    "Exclusion regions for mm9 by Barbara Wold, Caltech",
                    "hg19 centromere from the UCSC gap table", 
                    "hg19 clone from the UCSC gap table", 
                    "hg19 contig from the UCSC gap table", 
                    "hg19 heterochromatin from the UCSC gap table", 
                    "hg19 scaffold from the UCSC gap table", 
                    "hg19 short_arm from the UCSC gap table", 
                    "hg19 telomere from the UCSC gap table", 
                    "hg38 contig from the UCSC gap table", 
                    "hg38 heterochromatin from the UCSC gap table", 
                    "hg38 scaffold from the UCSC gap table", 
                    "hg38 short_arm from the UCSC gap table", 
                    "hg38 telomere from the UCSC gap table", 
                    "mm10 centromere from the UCSC gap table", 
                    "mm10 clone from the UCSC gap table", 
                    "mm10 contig from the UCSC gap table", 
                    "mm10 fragment from the UCSC gap table", 
                    "mm10 other from the UCSC gap table", 
                    "mm10 short_arm from the UCSC gap table", 
                    "mm10 telomere from the UCSC gap table", 
                    "mm9 centromere from the UCSC gap table", 
                    "mm9 contig from the UCSC gap table", 
                    "mm9 fragment from the UCSC gap table",
                    "mm10 scaffold from the UCSC gap table"),
    BiocVersion = rep("3.14", 42),
    Genome = c("ce10", 
               "dm3", 
               "hg19", 
               "hg19", 
               "hg19", 
               "hg19", 
               "hg19", 
               "hg38", 
               "hg38", 
               "hg38", 
               "hg38", 
               "hg38", 
               "hg38", 
               "mm10", 
               "mm10", 
               "mm10", 
               "mm10", 
               "mm10", 
               "mm9",
               "hg19", 
               "hg19", 
               "hg19", 
               "hg19", 
               "hg19", 
               "hg19", 
               "hg19", 
               "hg38", 
               "hg38", 
               "hg38", 
               "hg38", 
               "hg38", 
               "mm10", 
               "mm10", 
               "mm10", 
               "mm10", 
               "mm10", 
               "mm10", 
               "mm10", 
               "mm9", 
               "mm9", 
               "mm9",
               "mm10"),
    SourceType = rep("RDS", 42),
    SourceUrl = rep("https://drive.google.com/drive/folders/1MFn6LPZD1zZRQz7biR0Fyl-mzkx4CIxS?usp=sharing", 42),
    SourceVersion = rep("August 22 2021", 42),
    Species = c("Caenorhabditis elegans", "Drosophila melanogaster", rep("Homo sapiens", 11), rep("Mus musculus", 6), rep("Homo sapiens", 12), rep("Mus musculus", 11)),
    TaxonomyId = c(6239, 7227, rep(9606, 11), rep(10090, 6), rep(9606, 12), rep(10090, 11)),
    Coordinate_1_based = rep(TRUE, 42),
    DataProvider = c(rep("mitra.stanford.edu/kundaje/akundaje/release/blacklists/", 2), rep("ENCODE", 17), rep("UCSC", 23)),
    Maintainer = rep("Mikhail Dozmorov <mikhail.dozmorov@gmail.com>", 42),
    RDataClass = rep("GRanges", 42),
    DispatchClass = rep("RDS", 42),
    RDataPath = c("excluderanges/ce10.Kundaje.ce10-Excludable.rds",
                  "excluderanges/dm3.Kundaje.dm3-Excludable.rds",
                  "excluderanges/hg19.Bernstein.Mint_Excludable_hg19.rds",
                  "excluderanges/hg19.Birney.wgEncodeDacMapabilityConsensusExcludable.rds",
                  "excluderanges/hg19.Crawford.wgEncodeDukeMapabilityRegionsExcludable.rds",
                  "excluderanges/hg19.Wold.hg19mitoExcludable.rds",
                  "excluderanges/hg19.Yeo.eCLIP_Excludableregions.hg19.rds",
                  "excluderanges/hg38.Bernstein.Mint_Excludable_GRCh38.rds",
                  "excluderanges/hg38.Kundaje.GRCh38.Excludable.rds",
                  "excluderanges/hg38.Kundaje.GRCh38_unified_Excludable.rds",
                  "excluderanges/hg38.Reddy.wgEncodeDacMapabilityConsensusExcludable.hg38.rds",
                  "excluderanges/hg38.Wold.hg38mitoExcludable.rds",
                  "excluderanges/hg38.Yeo.eCLIP_Excludableregions.hg38liftover.bed.fixed.rds",
                  "excluderanges/mm10.Hardison.Excludable.full.rds",
                  "excluderanges/mm10.Hardison.psuExcludable.mm10.rds",
                  "excluderanges/mm10.Kundaje.anshul.Excludable.mm10.rds",
                  "excluderanges/mm10.Kundaje.mm10.Excludable.rds",
                  "excluderanges/mm10.Wold.mm10mitoExcludable.rds",
                  "excluderanges/mm9.Wold.mm9mitoExcludable.rds",
                  "excluderanges/hg19.UCSC.centromere.rds",
                  "excluderanges/hg19.UCSC.clone.rds",
                  "excluderanges/hg19.UCSC.contig.rds",
                  "excluderanges/hg19.UCSC.heterochromatin.rds",
                  "excluderanges/hg19.UCSC.scaffold.rds",
                  "excluderanges/hg19.UCSC.short_arm.rds",
                  "excluderanges/hg19.UCSC.telomere.rds",
                  "excluderanges/hg38.UCSC.contig.rds",
                  "excluderanges/hg38.UCSC.heterochromatin.rds",
                  "excluderanges/hg38.UCSC.scaffold.rds",
                  "excluderanges/hg38.UCSC.short_arm.rds",
                  "excluderanges/hg38.UCSC.telomere.rds",
                  "excluderanges/mm10.UCSC.centromere.rds",
                  "excluderanges/mm10.UCSC.clone.rds",
                  "excluderanges/mm10.UCSC.contig.rds",
                  "excluderanges/mm10.UCSC.fragment.rds",
                  "excluderanges/mm10.UCSC.other.rds",
                  "excluderanges/mm10.UCSC.short_arm.rds",
                  "excluderanges/mm10.UCSC.telomere.rds",
                  "excluderanges/mm9.UCSC.centromere.rds",
                  "excluderanges/mm9.UCSC.contig.rds",
                  "excluderanges/mm9.UCSC.fragment.rds",
                  "excluderanges/mm10.UCSC.scaffold.rds"),
    Tags = c(paste("ce10;Anshul Kundaje;Stanford;exclusion;blacklisted"),
             paste("dm3;Anshul Kundaje;Stanford;exclusion;blacklisted"),
             paste("hg19;Bradley Bernstein;Broad;exclusion;blacklisted"),
             paste("hg19;Ewan Birney;EBI;exclusion;blacklisted"),
             paste("hg19;Gregory Crawford;Duke;exclusion;blacklisted"),
             paste("hg19;Barbara Wold;Caltech;exclusion;blacklisted"),
             paste("hg19;Gene Yeo;UCSD;exclusion;blacklisted"),
             paste("hg38;Bradley Bernstein;Broad;exclusion;blacklisted"),
             paste("hg38;Anshul Kundaje;Stanford;exclusion;blacklisted"),
             paste("hg38;Anshul Kundaje;Stanford;exclusion;blacklisted"),
             paste("hg38;Tim Reddy;Duke;exclusion;blacklisted"),
             paste("hg38;Barbara Wold;Caltech;exclusion;blacklisted"),
             paste("hg38;Gene Yeo;UCSD;exclusion;blacklisted"),
             paste("mm10;Ross Hardison;PennState;exclusion;blacklisted"),
             paste("mm10;Ross Hardison;PennState;exclusion;blacklisted"),
             paste("mm10;Anshul Kundaje;Stanford;exclusion;blacklisted"),
             paste("mm10;Anshul Kundaje;Stanford;exclusion;blacklisted"),
             paste("mm10;Barbara Wold;Caltech;exclusion;blacklisted"),
             paste("mm9;Barbara Wold;Caltech;exclusion;blacklisted"),
             "hg19;centromere;UCSC", 
             "hg19;clone;UCSC", 
             "hg19;contig;UCSC", 
             "hg19;heterochromatin;UCSC", 
             "hg19;scaffold;UCSC", 
             "hg19;short_arm;UCSC", 
             "hg19;telomere;UCSC", 
             "hg38;contig;UCSC", 
             "hg38;heterochromatin;UCSC", 
             "hg38;scaffold;UCSC", 
             "hg38;short_arm;UCSC", 
             "hg38;telomere;UCSC", 
             "mm10;centromere;UCSC", 
             "mm10;clone;UCSC", 
             "mm10;contig;UCSC", 
             "mm10;fragment;UCSC", 
             "mm10;other;UCSC", 
             "mm10;short_arm;UCSC", 
             "mm10;telomere;UCSC", 
             "mm9;centromere;UCSC", 
             "mm9;contig;UCSC", 
             "mm9;fragment;UCSC",
             "mm10;scaffold;UCSC"),
    Notes = "")

write.csv(meta, file="inst/extdata/metadata.csv", row.names=FALSE)
